# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2021"
name = "rln"
version = "2.0.1"
build = false
exclude = [
    "resources/tree_depth_10/",
    "resources/**/*.wasm",
]
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "APIs to manage, compute and verify zkSNARK proofs and RLN primitives"
homepage = "https://vac.dev"
documentation = "https://github.com/vacp2p/zerokit"
readme = "README.md"
license = "MIT OR Apache-2.0"
repository = "https://github.com/vacp2p/zerokit"

[package.metadata.docs.rs]
features = [
    "parallel",
    "pmtree-ft",
]

[features]
default = [
    "parallel",
    "pmtree-ft",
]
fullmerkletree = []
headers = ["safer-ffi/headers"]
multi-message-id = []
optimalmerkletree = []
parallel = [
    "rayon",
    "ark-ff/parallel",
    "ark-ec/parallel",
    "ark-std/parallel",
    "ark-poly/parallel",
    "ark-groth16/parallel",
    "ark-serialize/parallel",
    "zerokit_utils/parallel",
]
pmtree-ft = ["zerokit_utils/pmtree-ft"]
stateless = []

[lib]
name = "rln"
crate-type = [
    "rlib",
    "staticlib",
    "cdylib",
]
path = "src/lib.rs"
doctest = false
bench = false

[[bin]]
name = "generate-headers"
path = "src/bin/generate-headers.rs"
required-features = ["headers"]

[[test]]
name = "ffi"
path = "tests/ffi.rs"

[[test]]
name = "ffi_utils"
path = "tests/ffi_utils.rs"

[[test]]
name = "partial_proof"
path = "tests/partial_proof.rs"

[[test]]
name = "pm_tree"
path = "tests/pm_tree.rs"

[[test]]
name = "poseidon_tree"
path = "tests/poseidon_tree.rs"

[[test]]
name = "protocol"
path = "tests/protocol.rs"

[[test]]
name = "public"
path = "tests/public.rs"

[[test]]
name = "utils"
path = "tests/utils.rs"

[[bench]]
name = "partial_proof"
path = "benches/partial_proof.rs"
harness = false
required-features = ["pmtree-ft"]

[[bench]]
name = "pmtree_benchmark"
path = "benches/pmtree_benchmark.rs"
harness = false
required-features = ["pmtree-ft"]

[[bench]]
name = "poseidon_tree_benchmark"
path = "benches/poseidon_tree_benchmark.rs"
harness = false

[dependencies.ark-bn254]
version = "0.5.0"
features = ["std"]

[dependencies.ark-ec]
version = "0.5.0"
default-features = false

[dependencies.ark-ff]
version = "0.5.0"
default-features = false

[dependencies.ark-groth16]
version = "0.5.0"
default-features = false

[dependencies.ark-poly]
version = "0.5.0"
default-features = false

[dependencies.ark-relations]
version = "0.5.1"
features = ["std"]

[dependencies.ark-serialize]
version = "0.5.0"
default-features = false

[dependencies.ark-std]
version = "0.5.0"
default-features = false

[dependencies.byteorder]
version = "1.5.0"

[dependencies.cfg-if]
version = "1.0.4"

[dependencies.document-features]
version = "0.2.12"
optional = true

[dependencies.num-bigint]
version = "0.4.6"
features = ["std"]
default-features = false

[dependencies.num-traits]
version = "0.2.19"

[dependencies.prost]
version = "0.14.3"

[dependencies.rand]
version = "0.8.5"

[dependencies.rand_chacha]
version = "0.3.1"

[dependencies.rayon]
version = "1.11.0"
optional = true

[dependencies.ruint]
version = "1.17.2"
features = [
    "rand",
    "serde",
    "ark-ff-05",
]
default-features = false

[dependencies.safer-ffi]
version = "0.1.13"

[dependencies.serde]
version = "1.0.228"
features = ["derive"]

[dependencies.serde_json]
version = "1.0.149"

[dependencies.tempfile]
version = "3.27.0"

[dependencies.thiserror]
version = "2.0.18"

[dependencies.tiny-keccak]
version = "2.0.2"
features = ["keccak"]

[dependencies.zeroize]
version = "1.8.2"

[dependencies.zerokit_utils]
version = "1.2.0"
default-features = false

[dev-dependencies.ark-crypto-primitives]
version = "0.5.0"
features = [
    "snark",
    "sponge",
]
default-features = false

[dev-dependencies.criterion]
version = "0.8.2"
features = ["html_reports"]
